# class MIME::Multipart::Parser

- MIME::Multipart::Parser
- Reference
- Object

##
Overview

Parses multipart MIME messages.

###
Example

    require "mime/multipart"

    multipart = "--aA40\r\nContent-Type: text/plain\r\n\r\nbody\r\n--aA40--"
    parser = MIME::Multipart::Parser.new(IO::Memory.new(multipart), "aA40")

    while parser.has_next?
      parser.next do |headers, io|
        headers["Content-Type"] # => "text/plain"
        io.gets_to_end          # => "body"
      end
    end

Please note that the IO object yielded by `#next` is only valid until the block returns.

##
Defined in:

##
Constructors

- .new(io : IO, boundary : String)

  Creates a new `Multipart::Parser` which parses io with multipart boundary boundary.

##
Instance Method Summary

- #has_next?

  True if `#next` can be called legally.

- #next(&)

  Parses the next body part and yields headers as `HTTP::Headers` and the body text as an `IO`.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(io : IO, boundary : String) #

Creates a new `Multipart::Parser` which parses io with multipart boundary boundary.

##
Instance Method Detail

def has_next? #

True if `#next` can be called legally.

def next(&) #

Parses the next body part and yields headers as `HTTP::Headers` and the body text as an `IO`.

This method yields once instead of returning the values, because the IO object yielded to the block is only valid while the block is executing. The IO object will be closed as soon as the block returns. To store the content of the body part for longer than the block, the IO must be read into memory.

    require "mime/multipart"

    multipart = "--aA40\r\nContent-Type: text/plain\r\n\r\nbody\r\n--aA40--"
    parser = MIME::Multipart::Parser.new(IO::Memory.new(multipart), "aA40")
    parser.next do |headers, io|
      headers["Content-Type"] # => "text/plain"
      io.gets_to_end          # => "body"
    end